#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

#define MAXDIM 10
typedef int MATRICA[MAXDIM][MAXDIM];

//void prikazMatrice(int matrica[][10], int brojRedova, int brojKolona);
void prikazMatrice(MATRICA matrica, int brojRedova, int brojKolona);
void unosMatrice(MATRICA matrica, int *n, int *m);
void prikaziIndeksKoloneSaNajvecomSumom(MATRICA matrica, int n, int m);
int vratiSumuKoloneMatrice(MATRICA matrica, int n, int zadataKolona);
void prikaziIndeksKoloneSaNajvecomSumomBoljiNacin(MATRICA matrica, int n, int m);
void prikazGlavneDijagonaleMatrice(MATRICA matrica, int n);
void prikazSporedneDijagonaleMatrice(MATRICA matrica, int n);


int main(void) {
	//int matrica[10][10];
	/*
	int matrica[][3] = { 
		{3,2,1}, 
		{4,3,2}, 
		{5,4,3}, 
		{6,5,4} 
	};
	*/
	/*
	int matrica[10][10] = {
		{3,2,1},
		{4,3,2},
		{5,4,3},
		{6,5,4}
	};
	*/
	
	MATRICA matrica = {
		{3,2,1,4},
		{4,3,2,3},
		{5,4,3,2},
		{6,5,4,1}
	};
	int n = 4;
	int m = 4;

	//MATRICA matrica;
	//int n, m;

	//unosMatrice(matrica, &n, &m);

	prikazMatrice(matrica, n, m);

	//prikaziIndeksKoloneSaNajvecomSumom(matrica, n, m);
	prikaziIndeksKoloneSaNajvecomSumomBoljiNacin(matrica, n, m);
	prikazGlavneDijagonaleMatrice(matrica, n);//samo za kvadratnu matricu
	prikazSporedneDijagonaleMatrice(matrica, n);//samo za kvadratnu matricu
	system("pause");
	return 0;
}

void prikazMatrice(MATRICA matrica, int brojRedova, int brojKolona) {
	int i, j;
	printf("Elementi matrice su:\n");
	for (i = 0; i < brojRedova; i++) {
		for (j = 0; j < brojKolona; j++) {
			printf("%d\t", matrica[i][j]);
		}
		printf("\n");
	}
}

void unosMatrice(MATRICA matrica, int *n, int *m) {
	int i, j;
	printf("Unesite dimenziju matrice u formatu nxm:\n");
	scanf("%dx%d", n, m);
	printf("Unesite elemente matrice:\n");
	for (i = 0; i < *n; i++) {
		for (j = 0; j < *m;j++) {
			printf("Unesite [%d][%d] element:\n", i+1, j+1);
			scanf("%d", &matrica[i][j]);
		}
	}
}

void prikaziIndeksKoloneSaNajvecomSumom(MATRICA matrica, int n, int m) {
	int i, j, suma, maxSuma, maxIndeks;
	suma = 0;
	for (i = 0; i < n; i++) {
		suma = suma + matrica[i][0];
	}
	maxSuma = suma;
	maxIndeks = 0;
	for (j = 1; j < m; j++) {
		suma = 0;
		for (i = 0; i < n; i++) {
			suma = suma + matrica[i][j];
		}
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndeks = j;
		}
	}
	printf("Indeks kolone sa najvecom sumom je %d\n", maxIndeks);
}

int vratiSumuKoloneMatrice(MATRICA matrica, int n, int zadataKolona) {
	int i;
	int suma=0;
	for (i = 0; i < n; i++) {
		suma = suma+matrica[i][zadataKolona];
	}
	return suma;
}

void prikaziIndeksKoloneSaNajvecomSumomBoljiNacin(MATRICA matrica, int n, int m) {
	int i, j, suma, maxSuma, maxIndeks;

	maxSuma = vratiSumuKoloneMatrice(matrica, n, 0);
	maxIndeks = 0;
	for (j = 1; j < m; j++) {
		suma = vratiSumuKoloneMatrice(matrica, n, j);
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndeks = j;
		}
	}
	printf("Indeks kolone sa najvecom sumom je %d\n", maxIndeks);
}

void prikazGlavneDijagonaleMatrice(MATRICA matrica, int n) {
	int i;
	printf("Elementi na glavnoj dijagonali matrice su:\n");
	for (i = 0; i < n; i++) {
		printf("%d\t", matrica[i][i]);
	}
	printf("\n");
}

void prikazSporedneDijagonaleMatrice(MATRICA matrica, int n) {
	int i;
	printf("Elementi na sporednoj dijagonali matrice su:\n");
	for (i = 0; i < n; i++) {
		printf("%d\t", matrica[i][n-1-i]);
	}
	printf("\n");
}
